'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ValidationError;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Note: babel cannot inherit from built-in types like Error.
// that's why we use ES5 inheritance here.

/**
 * Error of this class is thrown when a Model validation fails.
 *
 * @param {Object} errors
 * @constructor
 */
function ValidationError(errors) {
  Error.call(this);
  Error.captureStackTrace(this, ValidationError);

  /**
   * Any data that describes the errors.
   *
   * @type {Object}
   */
  this.data = errors;

  /**
   * @type {number}
   */
  this.statusCode = 400;

  /**
   * @type {string}
   */
  this.message = (0, _stringify2.default)(errors, null, 2);
}

_util2.default.inherits(ValidationError, Error);